# std::basic_iostream< _CharT, _Traits > Class Template Reference

Inheritance diagram for std::basic_iostream< _CharT, _Traits >:

List of all members.

## Detailed Description

### template<typename _CharT, typename _Traits>
class std::basic_iostream< _CharT, _Traits >

This class multiply inherits from the input and output stream classes simply to provide a single interface.

Definition at line 776 of file istream.

## Public Types

- typedef ctype< _CharT > __ctype_type
- typedef ctype< _CharT > __ctype_type
- typedef basic_ios< _CharT,
  _Traits > __ios_type
- typedef basic_ios< _CharT,
  _Traits > __ios_type
- typedef basic_istream< _CharT,
  _Traits > __istream_type
- typedef num_get< _CharT, istreambuf_iterator<
  _CharT, _Traits > > __num_get_type
- typedef num_put< _CharT, ostreambuf_iterator<
  _CharT, _Traits > > __num_put_type
- typedef basic_ostream< _CharT,
  _Traits > __ostream_type
- typedef basic_streambuf< _CharT,
  _Traits > __streambuf_type
- typedef basic_streambuf< _CharT,
  _Traits > __streambuf_type
- typedef _CharT char_type
- enum event { erase_event, imbue_event, copyfmt_event }
- typedef void(*) event_callback (event, ios_base &, int)
- typedef _Ios_Fmtflags fmtflags
- typedef _Traits::int_type int_type
- typedef int io_state
- typedef _Ios_Iostate iostate
- typedef _Traits::off_type off_type
- typedef int open_mode
- typedef _Ios_Openmode openmode
- typedef _Traits::pos_type pos_type
- typedef int seek_dir
- typedef _Ios_Seekdir seekdir
- typedef std::streamoff streamoff
- typedef std::streampos streampos
- typedef _Traits traits_type

- typedef num_put< _CharT, ostreambuf_iterator<
  _CharT, _Traits > > __num_put_type

## Public Member Functions

- const locale & _M_getloc () const
- void _M_setstate (iostate __state)
- bool bad () const
- basic_iostream (basic_streambuf< _CharT, _Traits > *__sb)
- void clear (iostate __state=goodbit)
- basic_ios & copyfmt (const basic_ios &__rhs)
- bool eof () const
- void exceptions (iostate __except)
- iostate exceptions () const
- bool fail () const
- char_type fill (char_type __ch)
- char_type fill () const
- fmtflags flags (fmtflags __fmtfl)
- fmtflags flags () const
- __ostream_type & flush ()
- streamsize gcount () const
- template<> basic_istream< wchar_t > & getline (char_type *__s, streamsize __n, char_type __delim)
- template<> basic_istream< char > & getline (char_type *__s, streamsize __n, char_type __delim)
- locale getloc () const
- bool good () const
- template<> basic_istream< wchar_t > & ignore (streamsize __n, int_type __delim)
- template<> basic_istream< wchar_t > & ignore (streamsize __n)
- template<> basic_istream< char > & ignore (streamsize __n, int_type __delim)
- template<> basic_istream< char > & ignore (streamsize __n)
- locale imbue (const locale &__loc)
- long & iword (int __ix)
- char narrow (char_type __c, char __dfault) const
- streamsize precision (streamsize __prec)
- streamsize precision () const
- void *& pword (int __ix)
- basic_streambuf< _CharT, _Traits > * rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
- basic_streambuf< _CharT, _Traits > * rdbuf () const
- iostate rdstate () const
- void register_callback (event_callback __fn, int __index)
- __ostream_type & seekp (off_type, ios_base::seekdir)
- __ostream_type & seekp (pos_type)
- fmtflags setf (fmtflags __fmtfl, fmtflags __mask)
- fmtflags setf (fmtflags __fmtfl)
- void setstate (iostate __state)
- pos_type tellp ()
- basic_ostream< _CharT, _Traits > * tie (basic_ostream< _CharT, _Traits > *__tiestr)
- basic_ostream< _CharT, _Traits > * tie () const
- void unsetf (fmtflags __mask)
- char_type widen (char __c) const
- streamsize width (streamsize __wide)
- streamsize width () const
- virtual ~basic_iostream ()

Unformatted Output Functions
All the unformatted output functions have some common behavior. Each starts by constructing a temporary object of type std::basic_ostream::sentry. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to generate whatever data is appropriate for the type of the argument.

If an exception is thrown during insertion, ios_base::badbit will be turned on in the stream's error state. If badbit is on in the stream's exceptions mask, the exception will be rethrown without completing its actions.

- void _M_write (const char_type *__s, streamsize __n)
- __ostream_type & put (char_type __c)
- __ostream_type & write (const char_type *__s, streamsize __n)

Unformatted Input Functions
All the unformatted input functions have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to true. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

The number of characters extracted is stored for later retrieval by gcount().

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

- __istream_type & get (__streambuf_type &__sb)
- __istream_type & get (__streambuf_type &__sb, char_type __delim)
- __istream_type & get (char_type *__s, streamsize __n)
- __istream_type & get (char_type *__s, streamsize __n, char_type __delim)
- __istream_type & get (char_type &__c)
- int_type get ()
- __istream_type & getline (char_type *__s, streamsize __n)
- __istream_type & getline (char_type *__s, streamsize __n, char_type __delim)
- __istream_type & ignore (streamsize __n, int_type __delim)
- __istream_type & ignore (streamsize __n)
- __istream_type & ignore ()
- int_type peek ()
- __istream_type & putback (char_type __c)
- __istream_type & read (char_type *__s, streamsize __n)
- streamsize readsome (char_type *__s, streamsize __n)
- __istream_type & seekg (off_type, ios_base::seekdir)
- __istream_type & seekg (pos_type)
- int sync ()
- pos_type tellg ()
- __istream_type & unget ()

- operator void * () const
- bool operator! () const

Arithmetic Inserters
All the `operator<<` functions (aka formatted output functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_ostream::sentry. This can have several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to generate whatever data is appropriate for the type of the argument.

If an exception is thrown during insertion, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

- __ostream_type & operator<< (__streambuf_type *__sb)
- __ostream_type & operator<< (const void *__p)
- __ostream_type & operator<< (long double __f)
- __ostream_type & operator<< (float __f)
- __ostream_type & operator<< (double __f)
- __ostream_type & operator<< (unsigned long long __n)
- __ostream_type & operator<< (long long __n)
- __ostream_type & operator<< (unsigned int __n)
- __ostream_type & operator<< (int __n)
- __ostream_type & operator<< (unsigned short __n)
- __ostream_type & operator<< (short __n)
- __ostream_type & operator<< (bool __n)
- __ostream_type & operator<< (unsigned long __n)
- __ostream_type & operator<< (long __n)

- __ostream_type & operator<< (ios_base &(*__pf)(ios_base &))
- __ostream_type & operator<< (__ios_type &(*__pf)(__ios_type &))
- __ostream_type & operator<< (__ostream_type &(*__pf)(__ostream_type &))

Arithmetic Extractors
All the `operator>>` functions (aka formatted input functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to false. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

- __istream_type & operator>> (__streambuf_type *__sb)
- __istream_type & operator>> (void *&__p)
- __istream_type & operator>> (long double &__f)
- __istream_type & operator>> (double &__f)
- __istream_type & operator>> (float &__f)
- __istream_type & operator>> (unsigned long long &__n)
- __istream_type & operator>> (long long &__n)
- __istream_type & operator>> (unsigned long &__n)
- __istream_type & operator>> (long &__n)
- __istream_type & operator>> (unsigned int &__n)
- __istream_type & operator>> (int &__n)
- __istream_type & operator>> (unsigned short &__n)
- __istream_type & operator>> (short &__n)
- __istream_type & operator>> (bool &__n)

- __istream_type & operator>> (ios_base &(*__pf)(ios_base &))
- __istream_type & operator>> (__ios_type &(*__pf)(__ios_type &))
- __istream_type & operator>> (__istream_type &(*__pf)(__istream_type &))

## Static Public Member Functions

- static bool sync_with_stdio (bool __sync=true)
- static int xalloc () throw ()

## Static Public Attributes

- static const fmtflags adjustfield
- static const openmode app
- static const openmode ate
- static const iostate badbit
- static const fmtflags basefield
- static const seekdir beg
- static const openmode binary
- static const fmtflags boolalpha
- static const seekdir cur
- static const fmtflags dec
- static const seekdir end
- static const iostate eofbit
- static const iostate failbit
- static const fmtflags fixed
- static const fmtflags floatfield
- static const iostate goodbit
- static const fmtflags hex
- static const openmode in
- static const fmtflags internal
- static const fmtflags left
- static const fmtflags oct
- static const openmode out
- static const fmtflags right
- static const fmtflags scientific
- static const fmtflags showbase
- static const fmtflags showpoint
- static const fmtflags showpos
- static const fmtflags skipws
- static const openmode trunc
- static const fmtflags unitbuf
- static const fmtflags uppercase

## Protected Types

- enum { _S_local_word_size }

## Protected Member Functions

- void _M_cache_locale (const locale &__loc)
- void _M_call_callbacks (event __ev) throw ()
- void _M_dispose_callbacks (void)
- template<typename _ValueT> __istream_type & _M_extract (_ValueT &__v)
- _Words & _M_grow_words (int __index, bool __iword)
- void _M_init ()
- template<typename _ValueT> __ostream_type & _M_insert (_ValueT __v)
- basic_iostream ()
- void init (basic_streambuf< _CharT, _Traits > *__sb)

## Protected Attributes

- _Callback_list * _M_callbacks
- const __ctype_type * _M_ctype
- char_type _M_fill
- bool _M_fill_init
- streamsize _M_gcount
- locale _M_ios_locale
- _Words _M_local_word [_S_local_word_size]
- const __num_get_type * _M_num_get
- const __num_put_type * _M_num_put
- basic_streambuf< _CharT, _Traits > * _M_streambuf
- basic_ostream< _CharT, _Traits > * _M_tie
- _Words * _M_word
- int _M_word_size
- _Words _M_word_zero

- iostate _M_exception
- fmtflags _M_flags
- streamsize _M_precision
- iostate _M_streambuf_state
- streamsize _M_width

## Friends

- template<typename _CharT2, typename _Traits2> basic_istream< _CharT2, _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, _CharT2 *)
- template<typename _CharT2, typename _Traits2> basic_istream< _CharT2, _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, _CharT2 &)
- class sentry
- class sentry

## Member Typedef Documentation

template<typename _CharT, typename _Traits>

typedef _CharT std::basic_iostream< _CharT, _Traits >::char_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_istream< _CharT, _Traits >.

Reimplemented in std::basic_fstream< _CharT, _Traits >, and std::basic_stringstream< _CharT, _Traits, _Alloc >.

Definition at line 784 of file istream.

typedef void(*) std::ios_base::event_callback(event, ios_base &, int)`[inherited]`

The type of an event callback function.

Parameters:

  | event | One of the members of the event enum.
  | ios_base | Reference to the ios_base object.
  | int | The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 435 of file ios_base.h.

typedef _Ios_Fmtflags std::ios_base::fmtflags`[inherited]`

This is a bitmask type.

`"_Ios_Fmtflags"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

- boolalpha
- dec
- fixed
- hex
- internal
- left
- oct
- right
- scientific
- showbase
- showpoint
- showpos
- skipws
- unitbuf
- uppercase
- adjustfield
- basefield
- floatfield

Definition at line 253 of file ios_base.h.

template<typename _CharT, typename _Traits>

typedef _Traits::int_type std::basic_iostream< _CharT, _Traits >::int_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_istream< _CharT, _Traits >.

Reimplemented in std::basic_fstream< _CharT, _Traits >, and std::basic_stringstream< _CharT, _Traits, _Alloc >.

Definition at line 785 of file istream.

typedef _Ios_Iostate std::ios_base::iostate`[inherited]`

This is a bitmask type.

`"_Ios_Iostate"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 328 of file ios_base.h.

template<typename _CharT, typename _Traits>

typedef _Traits::off_type std::basic_iostream< _CharT, _Traits >::off_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_istream< _CharT, _Traits >.

Reimplemented in std::basic_fstream< _CharT, _Traits >, and std::basic_stringstream< _CharT, _Traits, _Alloc >.

Definition at line 787 of file istream.

typedef _Ios_Openmode std::ios_base::openmode`[inherited]`

This is a bitmask type.

`"_Ios_Openmode"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 359 of file ios_base.h.

template<typename _CharT, typename _Traits>

typedef _Traits::pos_type std::basic_iostream< _CharT, _Traits >::pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_istream< _CharT, _Traits >.

Reimplemented in std::basic_fstream< _CharT, _Traits >, and std::basic_stringstream< _CharT, _Traits, _Alloc >.

Definition at line 786 of file istream.

typedef _Ios_Seekdir std::ios_base::seekdir`[inherited]`

This is an enumerated type.

`"_Ios_Seekdir"` is implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEK_CUR` in the C standard library.
- end, equivalent to `SEEK_END` in the C standard library.

Definition at line 392 of file ios_base.h.

template<typename _CharT, typename _Traits>

typedef _Traits std::basic_iostream< _CharT, _Traits >::traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_istream< _CharT, _Traits >.

Reimplemented in std::basic_fstream< _CharT, _Traits >, and std::basic_stringstream< _CharT, _Traits, _Alloc >.

Definition at line 788 of file istream.

## Member Enumeration Documentation

enum std::ios_base::event`[inherited]`

The set of events that may be passed to an event callback.

erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Definition at line 418 of file ios_base.h.

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits>

std::basic_iostream< _CharT, _Traits >::basic_iostream | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) | `[inline, explicit]`

Constructor does nothing.

Both of the parent classes are initialized with the same streambuf pointer passed to this constructor.

Definition at line 801 of file istream.

template<typename _CharT, typename _Traits>

virtual std::basic_iostream< _CharT, _Traits >::~basic_iostream | ( |  | ) | `[inline, virtual]`

Destructor does nothing.

Definition at line 809 of file istream.

## Member Function Documentation

const locale& std::ios_base::_M_getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 700 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::_M_extract(), std::num_get< _CharT, _InIter >::_M_extract_float(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::time_get< _CharT, _InIter >::_M_extract_name(), std::time_get< _CharT, _InIter >::_M_extract_num(), std::time_get< _CharT, _InIter >::_M_extract_via_format(), std::money_put< _CharT, _OutIter >::_M_insert(), std::num_put< _CharT, _OutIter >::_M_insert_float(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::__pad< _CharT, _Traits >::_S_pad(), std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::time_put< _CharT, _OutIter >::do_put(), std::num_put< _CharT, _OutIter >::do_put(), and std::time_put< _CharT, _OutIter >::put().

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::bad | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 197 of file basic_ios.h.

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::clear | ( | iostate | __state = `goodbit` | ) | `[inherited]`

[Re]sets the error state.

Parameters:

  | state | The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 45 of file basic_ios.tcc.

References __N.

Referenced by std::basic_ios< _CharT, _Traits >::rdbuf().

template<typename _CharT, typename _Traits>

basic_ios< _CharT, _Traits > & std::basic_ios< _CharT, _Traits >::copyfmt | ( | const basic_ios< _CharT, _Traits > & | __rhs | ) | `[inherited]`

Copies fields of __rhs into this.

Parameters:

  | __rhs | The source values for the copies.

Returns:
  Reference to this object.

All fields of __rhs are copied into this object except that rdbuf() and rdstate() remain unchanged. All values in the pword and iword arrays are copied. Before copying, each callback is invoked with erase_event. After copying, each (new) callback is invoked with copyfmt_event. The final step is to copy exceptions().

Definition at line 67 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::_M_cache_locale(), std::ios_base::_M_callbacks, std::ios_base::_M_ios_locale, std::ios_base::_M_local_word, std::ios_base::_M_word, std::ios_base::_M_word_size, std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_ios< _CharT, _Traits >::fill(), std::ios_base::flags(), std::ios_base::getloc(), std::ios_base::precision(), std::basic_ios< _CharT, _Traits >::tie(), and std::ios_base::width().

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::eof | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 176 of file basic_ios.h.

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::exceptions | ( | iostate | __except | ) | `[inline, inherited]`

Throwing exceptions on errors.

Parameters:

  | except | The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flage is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

      #include <iostream>
      #include <fstream>
      #include <exception>

      int main()
      {
          std::set_terminate (__gnu_cxx::__verbose_terminate_handler);

          std::ifstream f ("/etc/motd");

          std::cerr << "Setting badbit\n";
          f.setstate (std::ios_base::badbit);

          std::cerr << "Setting exception mask\n";
          f.exceptions (std::ios_base::badbit);
      }

Definition at line 243 of file basic_ios.h.

template<typename _CharT, typename _Traits>

iostate std::basic_ios< _CharT, _Traits >::exceptions | ( |  | ) | const`[inline, inherited]`

Throwing exceptions on errors.

Returns:
  The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 208 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt().

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::fail | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 187 of file basic_ios.h.

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::fill | ( | char_type | __ch | ) | `[inline, inherited]`

Sets a new "empty" character.

Parameters:

  | ch | The new character.

Returns:
  The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 376 of file basic_ios.h.

References std::fill().

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::fill | ( |  | ) | const`[inline, inherited]`

Retreives the "empty" character.

Returns:
  The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 356 of file basic_ios.h.

Referenced by std::__ostream_fill(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::operator<<(), and std::operator>>().

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) | `[inline, inherited]`

Setting new format flags all at once.

Parameters:

  | fmtfl | The new flags to set.

Returns:
  The previous format control flags.

This function overwrites all the format flags with fmtfl.

Definition at line 558 of file ios_base.h.

fmtflags std::ios_base::flags | ( |  | ) | const`[inline, inherited]`

Access to format flags.

Returns:
  The format control flags for both input and output.

Definition at line 548 of file ios_base.h.

Referenced by std::__ostream_insert(), std::money_get< _CharT, _InIter >::_M_extract(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::money_put< _CharT, _OutIter >::_M_insert(), std::num_put< _CharT, _OutIter >::_M_insert_float(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::__pad< _CharT, _Traits >::_S_pad(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), __gnu_cxx::operator<<(), std::tr1::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), and std::tr1::operator>>().

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::flush | ( |  | ) | `[inherited]`

Synchronizing the stream buffer.

Returns:
  *this

If `rdbuf()` is a null pointer, changes nothing.

Otherwise, calls `rdbuf()->pubsync()`, and if that returns -1, sets badbit.

Definition at line 196 of file ostream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

Referenced by std::flush().

template<typename _CharT, typename _Traits>

streamsize std::basic_istream< _CharT, _Traits >::gcount | ( |  | ) | const`[inline, inherited]`

Character counting.

Returns:
  The number of characters extracted by the previous unformatted input function dispatched for this stream.

Definition at line 260 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::get | ( | __streambuf_type & | __sb | ) | `[inline, inherited]`

Extraction into another streambuf.

Parameters:

  | sb | A streambuf in which to store data.

Returns:
  *this

Returns `get`(sb,widen('
')).

Definition at line 377 of file istream.

References std::tr1::get().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | __streambuf_type & | __sb,
|  | char_type | __delim |
| ) |  |  | `[inherited]`

Extraction into another streambuf.

Parameters:

  | sb | A streambuf in which to store data.
  | delim | A "stop" character.

Returns:
  *this

Characters are extracted and inserted into sb until one of the following happens:

- the input sequence reaches EOF
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted)
- the next character equals delim (in this case, the character is not extracted)
- an exception occurs (and in this case is caught)

If no characters are stored, failbit is set in the stream's error state.

Definition at line 287 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::setstate(), std::basic_streambuf< _CharT, _Traits >::sgetc(), std::basic_streambuf< _CharT, _Traits >::snextc(), and std::basic_streambuf< _CharT, _Traits >::sputc().

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::get | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Simple multiple-character extraction.

Parameters:

  | s | Pointer to an array.
  | n | Maximum number of characters to store in s.

Returns:
  *this

Returns `get`(s,n,widen('
')).

Definition at line 344 of file istream.

References std::tr1::get().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim |
| ) |  |  | `[inherited]`

Simple multiple-character extraction.

Parameters:

  | s | Pointer to an array.
  | n | Maximum number of characters to store in s.
  | delim | A "stop" character.

Returns:
  *this

Characters are extracted and stored into s until one of the following happens:

- `n-1` characters are stored
- the input sequence reaches EOF
- the next character equals delim, in which case the character is not extracted

If no characters are stored, failbit is set in the stream's error state.

In any case, a null character is stored into the next location in the array.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 245 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::setstate(), std::basic_streambuf< _CharT, _Traits >::sgetc(), and std::basic_streambuf< _CharT, _Traits >::snextc().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | char_type & | __c | ) | `[inherited]`

Simple extraction.

Parameters:

  | c | The character in which to store data.

Returns:
  *this

Tries to extract a character and store it in c. If none are available, sets failbit and returns traits::eof().

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 213 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::get | ( |  | ) | `[inherited]`

Simple extraction.

Returns:
  A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

Definition at line 182 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::getline | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

String extraction.

Parameters:

  | s | A character array in which to store the data.
  | n | Maximum number of characters to extract.

Returns:
  *this

Returns `getline`(s,n,widen('
')).

Definition at line 417 of file istream.

References __gnu_debug::getline().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::getline | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim |
| ) |  |  | `[inherited]`

String extraction.

Parameters:

  | s | A character array in which to store the data.
  | n | Maximum number of characters to extract.
  | delim | A "stop" character.

Returns:
  *this

Extracts and stores characters into s until one of the following happens. Note that these criteria are required to be tested in the order listed here, to allow an input line to exactly fill the s array without setting failbit.

1. the input sequence reaches end-of-file, in which case eofbit is set in the stream error state
2. the next character equals `delim`, in which case the character is extracted (and therefore counted in `gcount()`) but not stored
3. `n-1` characters are stored, in which case failbit is set in the stream error state

If no characters are extracted, failbit is set. (An empty line of input should therefore not cause failbit to be set.)

In any case, a null character is stored in the next location in the array.

Definition at line 326 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_streambuf< _CharT, _Traits >::sbumpc(), std::basic_ios< _CharT, _Traits >::setstate(), std::basic_streambuf< _CharT, _Traits >::sgetc(), and std::basic_streambuf< _CharT, _Traits >::snextc().

locale std::ios_base::getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  A copy of the current locale.

If `imbue(loc)` has previously been called, then this function returns `loc`. Otherwise, it returns a copy of `std::locale()`, the global C++ locale.

Definition at line 690 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::money_put< _CharT, _OutIter >::do_put(), std::operator>>(), and std::ws().

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::good | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if no error flags are set.

A wrapper around rdstate.

Definition at line 166 of file basic_ios.h.

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore | ( | streamsize | __n,
|  | int_type | __delim |
| ) |  |  | `[inherited]`

Extraction into another streambuf.

Parameters:

  | sb | A streambuf in which to store data.

Returns:
  *this

Returns `get`(sb,widen('
')).

Definition at line 465 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::goodbit, std::max(), std::min(), std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_streambuf< _CharT, _Traits >::sbumpc(), std::basic_ios< _CharT, _Traits >::setstate(), std::basic_streambuf< _CharT, _Traits >::sgetc(), and std::basic_streambuf< _CharT, _Traits >::snextc().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore | ( | streamsize | __n | ) | `[inherited]`

Extraction into another streambuf.

Parameters:

  | sb | A streambuf in which to store data.

Returns:
  *this

Returns `get`(sb,widen('
')).

Definition at line 409 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::goodbit, std::max(), std::min(), std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::setstate(), std::basic_streambuf< _CharT, _Traits >::sgetc(), and std::basic_streambuf< _CharT, _Traits >::snextc().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore | ( |  | ) | `[inherited]`

Discarding characters.

Parameters:

  | n | Number of characters to discard.
  | delim | A "stop" character.

Returns:
  *this

Extracts characters and throws them away until one of the following happens:

- if n `!=` `std::numeric_limits<int>::max()`, n characters are extracted
- the input sequence reaches end-of-file
- the next character equals delim (in this case, the character is extracted); note that this condition will never occur if delim equals `traits::eof()`.

NB: Provide three overloads, instead of the single function (with defaults) mandated by the Standard: this leads to a better performing implementation, while still conforming to the Standard.

Definition at line 381 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_streambuf< _CharT, _Traits >::sbumpc(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

locale std::basic_ios< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) | `[inherited]`

Moves to a new locale.

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls `ios_base::imbue(loc)`, and if a stream buffer is associated with this stream, calls that buffer's `pubimbue(loc)`.

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Reimplemented from std::ios_base.

Definition at line 128 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::_M_cache_locale(), and std::ios_base::imbue().

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::init | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) | `[protected, inherited]`

All setup is performed here.

This is called from the public constructor. It is not virtual and cannot be redefined.

Definition at line 140 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::_M_cache_locale(), std::ios_base::_M_exception, std::basic_ios< _CharT, _Traits >::_M_fill, std::basic_ios< _CharT, _Traits >::_M_fill_init, std::ios_base::_M_ios_locale, std::basic_ios< _CharT, _Traits >::_M_streambuf, std::ios_base::_M_streambuf_state, std::basic_ios< _CharT, _Traits >::_M_tie, std::ios_base::badbit, and std::ios_base::goodbit.

long& std::ios_base::iword | ( | int | __ix | ) | `[inline, inherited]`

Access to integer array.

Parameters:

  | __ix | Index into the array.

Returns:
  A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 734 of file ios_base.h.

References std::ios_base::_Words::_M_iword.

template<typename _CharT, typename _Traits>

char std::basic_ios< _CharT, _Traits >::narrow | ( | char_type | __c,
|  | char | __dfault |
| ) |  |  | const`[inherited]`

Squeezes characters.

Parameters:

  | c | The character to narrow.
  | dfault | The character to narrow.

Returns:
  The narrowed character.

Maps a character of `char_type` to a character of `char`, if possible.

Returns the result of

        std::use_facet<ctype<char_type> >(getloc()).narrow(c,dfault)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 117 of file basic_ios.tcc.

References std::__check_facet(), and std::basic_ios< _CharT, _Traits >::_M_ctype.

template<typename _CharT, typename _Traits>

std::basic_ios< _CharT, _Traits >::operator void * | ( |  | ) | const`[inline, inherited]`

The quick-and-easy status check.

This allows you to write constructs such as "if (!a_stream) ..." and "while (a_stream) ..."

Definition at line 107 of file basic_ios.h.

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::operator! | ( |  | ) | const`[inline, inherited]`

The quick-and-easy status check.

This allows you to write constructs such as "if (!a_stream) ..." and "while (a_stream) ..."

Definition at line 111 of file basic_ios.h.

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::operator<< | ( | __streambuf_type * | __sb | ) | `[inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 120 of file ostream.tcc.

References std::__copy_streambufs(), std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::failbit, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | const void * | __p | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 229 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | long double | __f | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 225 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | float | __f | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 217 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | double | __f | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 213 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | unsigned long long | __n | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 208 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | long long | __n | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 204 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | unsigned int | __n | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 195 of file ostream.

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::operator<< | ( | int | __n | ) | `[inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 106 of file ostream.tcc.

References std::basic_ostream< _CharT, _Traits >::_M_insert(), std::ios_base::basefield, std::ios_base::flags(), std::ios_base::hex, and std::ios_base::oct.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | unsigned short | __n | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 184 of file ostream.

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::operator<< | ( | short | __n | ) | `[inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 92 of file ostream.tcc.

References std::basic_ostream< _CharT, _Traits >::_M_insert(), std::ios_base::basefield, std::ios_base::flags(), std::ios_base::hex, and std::ios_base::oct.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | bool | __n | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 177 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | unsigned long | __n | ) | `[inline, inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 173 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | long | __n | ) | `[inline, inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 169 of file ostream.

template<typename _CharT, typename _Traits>

__ostream_type& std::basic_ostream< _CharT, _Traits >::operator<< | ( | __ostream_type &(*)(__ostream_type &) | __pf | ) | `[inline, inherited]`

Interface for manipulators.

Manuipulators such as `std::endl` and `std::hex` use these functions in constructs like "std::cout << std::endl". For more information, see the iomanip header.

Definition at line 112 of file ostream.

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | __streambuf_type * | __sb | ) | `[inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 155 of file istream.tcc.

References std::__copy_streambufs_eof(), std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | void *& | __p | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 226 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | long double & | __f | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 222 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | double & | __f | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 218 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | float & | __f | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 214 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned long long & | __n | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 209 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | long long & | __n | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 205 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned long & | __n | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 200 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | long & | __n | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 196 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned int & | __n | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 192 of file istream.

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | int & | __n | ) | `[inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 135 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_extract(), std::ios_base::failbit, and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned short & | __n | ) | `[inline, inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 185 of file istream.

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | short & | __n | ) | `[inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 115 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_extract(), std::ios_base::failbit, and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | bool & | __n | ) | `[inline, inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 178 of file istream.

template<typename _CharT, typename _Traits>

__istream_type& std::basic_istream< _CharT, _Traits >::operator>> | ( | __istream_type &(*)(__istream_type &) | __pf | ) | `[inline, inherited]`

Interface for manipulators.

Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header.

Definition at line 131 of file istream.

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::peek | ( |  | ) | `[inherited]`

Looking ahead in the stream.

Returns:
  The next character, or eof().

If, after constructing the sentry object, `good()` is false, returns `traits::eof()`. Otherwise reads but does not extract the next input character.

Definition at line 523 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

streamsize std::ios_base::precision | ( | streamsize | __prec | ) | `[inline, inherited]`

Changing flags.

Parameters:

  | prec | The new precision value.

Returns:
  The previous value of precision().

Definition at line 626 of file ios_base.h.

streamsize std::ios_base::precision | ( |  | ) | const`[inline, inherited]`

Flags access.

Returns:
  The precision to generate on certain output operations.

Definition at line 618 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::_M_insert_float(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::operator<<(), and std::operator>>().

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::put | ( | char_type | __c | ) | `[inherited]`

Simple insertion.

Parameters:

  | c | The character to insert.

Returns:
  *this

Tries to insert c.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 144 of file ostream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

Referenced by std::endl(), and std::ends().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::putback | ( | char_type | __c | ) | `[inherited]`

Unextracting a single character.

Parameters:

  | c | The character to push back into the input stream.

Returns:
  *this

If `rdbuf()` is not null, calls `rdbuf()->sputbackc(c)`.

If `rdbuf()` is null or if `sputbackc()` fails, sets badbit in the error state.

Note:
  Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 599 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::setstate(), and std::basic_streambuf< _CharT, _Traits >::sputbackc().

void*& std::ios_base::pword | ( | int | __ix | ) | `[inline, inherited]`

Access to void pointer array.

Parameters:

  | __ix | Index into the array.

Returns:
  A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 755 of file ios_base.h.

References std::ios_base::_Words::_M_pword.

template<typename _CharT, typename _Traits>

basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) | `[inherited]`

Changing the underlying buffer.

Parameters:

  | sb | The new stream buffer.

Returns:
  The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument `rdbuf()`, which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class. For example:

      std::fstream     foo;         // or some other derived type
      std::streambuf*  p = .....;

      foo.ios::rdbuf(p);            // ios == basic_ios<char>

Definition at line 57 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::_M_streambuf, and std::basic_ios< _CharT, _Traits >::clear().

template<typename _CharT, typename _Traits>

basic_streambuf<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::rdbuf | ( |  | ) | const`[inline, inherited]`

Accessing the underlying buffer.

Returns:
  The current stream buffer.

This does not change the state of the stream.

Reimplemented in std::basic_ifstream< _CharT, _Traits >, std::basic_ofstream< _CharT, _Traits >, std::basic_fstream< _CharT, _Traits >, std::basic_istringstream< _CharT, _Traits, _Alloc >, std::basic_ostringstream< _CharT, _Traits, _Alloc >, and std::basic_stringstream< _CharT, _Traits, _Alloc >.

Definition at line 307 of file basic_ios.h.

Referenced by std::__ostream_fill(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

template<typename _CharT, typename _Traits>

iostate std::basic_ios< _CharT, _Traits >::rdstate | ( |  | ) | const`[inline, inherited]`

Returns the error state of the stream buffer.

Returns:
  A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 123 of file basic_ios.h.

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::read | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inherited]`

Extraction without delimiters.

Parameters:

  | s | A character array.
  | n | Maximum number of characters to store.

Returns:
  *this

If the stream state is `good()`, extracts characters and stores them into s until one of the following happens:

- n characters are stored
- the input sequence reaches end-of-file, in which case the error state is set to `failbit|eofbit`.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 548 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

streamsize std::basic_istream< _CharT, _Traits >::readsome | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inherited]`

Extraction until the buffer is exhausted, but no more.

Parameters:

  | s | A character array.
  | n | Maximum number of characters to store.

Returns:
  The number of characters extracted.

Extracts characters and stores them into s depending on the number of characters remaining in the streambuf's buffer, `rdbuf()->in_avail()`, called `A` here:

- if `A` `==` `-1`, sets eofbit and extracts no characters
- if `A` `==` `0`, extracts no characters
- if `A` `>` `0`, extracts `min(A,n)`

The goal is to empty the current buffer, and to not request any more from the external input sequence controlled by the streambuf.

Definition at line 572 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::goodbit, std::min(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | __index |
| ) |  |  | `[inherited]`

Add the callback __fn with parameter __index.

Parameters:

  | __fn | The function to add.
  | __index | The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg | ( | off_type | ,
|  | ios_base::seekdir |  |
| ) |  |  | `[inherited]`

Changing the current read position.

Parameters:

  | off | A file offset object.
  | dir | The direction in which to seek.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekoff(off,dir)`. If that function fails, sets failbit.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 733 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::in, and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg | ( | pos_type |  | ) | `[inherited]`

Changing the current read position.

Parameters:

  | pos | A file position object.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekpos(pos)`. If that function fails, sets failbit.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 705 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::in, and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::seekp | ( | off_type | ,
|  | ios_base::seekdir |  |
| ) |  |  | `[inherited]`

Changing the current write position.

Parameters:

  | off | A file offset object.
  | dir | The direction in which to seek.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekoff(off,dir)`. If that function fails, sets failbit.

Definition at line 260 of file ostream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::out, and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::seekp | ( | pos_type |  | ) | `[inherited]`

Changing the current write position.

Parameters:

  | pos | A file position object.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekpos(pos)`. If that function fails, sets failbit.

Definition at line 233 of file ostream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::out, and std::basic_ios< _CharT, _Traits >::setstate().

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask |
| ) |  |  | `[inline, inherited]`

Setting new format flags.

Parameters:

  | fmtfl | Additional flags to set.
  | mask | The flags mask for fmtfl.

Returns:
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield`.

Definition at line 591 of file ios_base.h.

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) | `[inline, inherited]`

Setting new format flags.

Parameters:

  | fmtfl | Additional flags to set.

Returns:
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 574 of file ios_base.h.

Referenced by std::boolalpha(), std::dec(), std::fixed(), std::hex(), std::internal(), std::left(), std::oct(), std::operator<<(), std::operator>>(), std::right(), std::scientific(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::setstate | ( | iostate | __state | ) | `[inline, inherited]`

Sets additional flags in the error state.

Parameters:

  | state | The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 143 of file basic_ios.h.

Referenced by std::__ostream_fill(), std::basic_istream< _CharT, _Traits >::_M_extract(), std::basic_ostream< _CharT, _Traits >::_M_insert(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

template<typename _CharT, typename _Traits>

int std::basic_istream< _CharT, _Traits >::sync | ( |  | ) | `[inherited]`

Synchronizing the stream buffer.

Returns:
  0 on success, -1 on failure

If `rdbuf()` is a null pointer, returns -1.

Otherwise, calls `rdbuf()->pubsync()`, and if that returns -1, sets badbit and returns -1.

Otherwise, returns 0.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 655 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::goodbit, std::basic_streambuf< _CharT, _Traits >::pubsync(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

static bool std::ios_base::sync_with_stdio | ( | bool | __sync = `true` | ) | `[static, inherited]`

Interaction with the standard C I/O objects.

Parameters:

  | sync | Whether to synchronize or not.

Returns:
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#8 for more.

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits >::pos_type std::basic_istream< _CharT, _Traits >::tellg | ( |  | ) | `[inherited]`

Getting the current read position.

Returns:
  A file position object.

If `fail()` is not false, returns `pos_type`(-1) to indicate failure. Otherwise returns `rdbuf()->pubseekoff(0,cur,in)`.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 686 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::cur, and std::ios_base::in.

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits >::pos_type std::basic_ostream< _CharT, _Traits >::tellp | ( |  | ) | `[inherited]`

Getting the current write position.

Returns:
  A file position object.

If `fail()` is not false, returns `pos_type`(-1) to indicate failure. Otherwise returns `rdbuf()->pubseekoff(0,cur,out)`.

Definition at line 217 of file ostream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::cur, and std::ios_base::out.

template<typename _CharT, typename _Traits>

basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie | ( | basic_ostream< _CharT, _Traits > * | __tiestr | ) | `[inline, inherited]`

Ties this stream to an output stream.

Parameters:

  | tiestr | The output stream.

Returns:
  The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 293 of file basic_ios.h.

template<typename _CharT, typename _Traits>

basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie | ( |  | ) | const`[inline, inherited]`

Fetches the current tied stream.

Returns:
  A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, `std::cin` is tied to `std::cout`.

Definition at line 281 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt().

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::unget | ( |  | ) | `[inherited]`

Unextracting the previous character.

Returns:
  *this

If `rdbuf()` is not null, calls `rdbuf()->sungetc(c)`.

If `rdbuf()` is null or if `sungetc()` fails, sets badbit in the error state.

Note:
  Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 627 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::basic_ios< _CharT, _Traits >::_M_setstate(), std::ios_base::badbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::setstate(), and std::basic_streambuf< _CharT, _Traits >::sungetc().

void std::ios_base::unsetf | ( | fmtflags | __mask | ) | `[inline, inherited]`

Clearing format flags.

Parameters:

  | mask | The flags to unset.

This function clears mask in the format flags.

Definition at line 606 of file ios_base.h.

Referenced by std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), and std::nouppercase().

template<typename _CharT, typename _Traits>

_CharT std::basic_ios< _CharT, _Traits >::widen | ( | char | __c | ) | const`[inherited]`

Widens characters.

Parameters:

  | c | The character to widen.

Returns:
  The widened character.

Maps a character of `char` to a character of `char_type`.

Returns the result of

        std::use_facet<ctype<char_type> >(getloc()).widen(c)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 122 of file basic_ios.tcc.

References std::__check_facet(), and std::basic_ios< _CharT, _Traits >::_M_ctype.

Referenced by std::endl(), std::getline(), and std::operator>>().

streamsize std::ios_base::width | ( | streamsize | __wide | ) | `[inline, inherited]`

Changing flags.

Parameters:

  | wide | The new width value.

Returns:
  The previous value of width().

Definition at line 648 of file ios_base.h.

streamsize std::ios_base::width | ( |  | ) | const`[inline, inherited]`

Flags access.

Returns:
  The minimum field width to generate on output operations.

"Minimum field width" refers to the number of characters.

Definition at line 640 of file ios_base.h.

Referenced by std::__ostream_insert(), std::money_put< _CharT, _OutIter >::_M_insert(), std::num_put< _CharT, _OutIter >::_M_insert_float(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_put< _CharT, _OutIter >::do_put(), __gnu_cxx::operator<<(), std::operator<<(), and std::operator>>().

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::write | ( | const char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inherited]`

Character string insertion.

Parameters:

  | s | The array to insert.
  | n | Maximum number of characters to insert.

Returns:
  *this

Characters are copied from s and inserted into the stream until one of the following happens:

- n characters are inserted
- inserting into the output sequence fails (in this case, badbit will be set in the stream's error state)

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 173 of file ostream.tcc.

References std::basic_ios< _CharT, _Traits >::_M_setstate(), std::basic_ostream< _CharT, _Traits >::_M_write(), and std::ios_base::badbit.

static int std::ios_base::xalloc | ( |  | ) | throw ()`[static, inherited]`

Access to unique indices.

Returns:
  An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

## Member Data Documentation

const fmtflags std::ios_base::adjustfield`[static, inherited]`

A mask of left|right|internal. Useful for the 2-arg form of `setf`.

Definition at line 308 of file ios_base.h.

Referenced by std::money_put< _CharT, _OutIter >::_M_insert(), and std::__pad< _CharT, _Traits >::_S_pad().

const openmode std::ios_base::app`[static, inherited]`

Seek to end before each write.

Definition at line 362 of file ios_base.h.

const openmode std::ios_base::ate`[static, inherited]`

Open and seek to end immediately after opening.

Definition at line 365 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open().

const iostate std::ios_base::badbit`[static, inherited]`

as an irrecoverable read error from a file).

Definition at line 332 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::_M_extract(), std::basic_ostream< _CharT, _Traits >::_M_insert(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_ios< _CharT, _Traits >::init(), std::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_ostream< _CharT, _Traits >::tellp(), std::basic_istream< _CharT, _Traits >::unget(), and std::basic_ostream< _CharT, _Traits >::write().

const fmtflags std::ios_base::basefield`[static, inherited]`

A mask of dec|oct|hex. Useful for the 2-arg form of `setf`.

Definition at line 311 of file ios_base.h.

Referenced by std::__int_to_char(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::basic_ostream< _CharT, _Traits >::operator<<().

const seekdir std::ios_base::beg`[static, inherited]`

Request a seek relative to the beginning of the stream.

Definition at line 395 of file ios_base.h.

Referenced by __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::seekoff(), __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::seekpos().

const openmode std::ios_base::binary`[static, inherited]`

http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more.

Definition at line 371 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::showmanyc().

const fmtflags std::ios_base::boolalpha`[static, inherited]`

Insert/extract `bool` in alphabetic rather than numeric format.

Definition at line 256 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), and std::num_put< _CharT, _OutIter >::do_put().

const seekdir std::ios_base::cur`[static, inherited]`

Request a seek relative to the current position within the sequence.

Definition at line 398 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

const fmtflags std::ios_base::dec`[static, inherited]`

Converts integer input or generates integer output in decimal base.

Definition at line 259 of file ios_base.h.

const seekdir std::ios_base::end`[static, inherited]`

Request a seek relative to the current end of the sequence.

Definition at line 401 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

const iostate std::ios_base::eofbit`[static, inherited]`

Indicates that an input operation reached the end of an input sequence.

Definition at line 335 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::_M_extract(), std::num_get< _CharT, _InIter >::_M_extract_float(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), and std::ws().

const iostate std::ios_base::failbit`[static, inherited]`

desired characters.

Definition at line 340 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::_M_extract(), std::num_get< _CharT, _InIter >::_M_extract_float(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::time_get< _CharT, _InIter >::_M_extract_name(), std::time_get< _CharT, _InIter >::_M_extract_num(), std::time_get< _CharT, _InIter >::_M_extract_via_format(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::seekg(), and std::basic_ostream< _CharT, _Traits >::seekp().

const fmtflags std::ios_base::fixed`[static, inherited]`

Generate floating-point output in fixed-point notation.

Definition at line 262 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::_M_insert_float().

const fmtflags std::ios_base::floatfield`[static, inherited]`

A mask of scientific|fixed. Useful for the 2-arg form of `setf`.

Definition at line 314 of file ios_base.h.

const iostate std::ios_base::goodbit`[static, inherited]`

Indicates all is well.

Definition at line 343 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::_M_extract(), std::time_get< _CharT, _InIter >::_M_extract_via_format(), std::basic_ostream< _CharT, _Traits >::_M_insert(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_ios< _CharT, _Traits >::init(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), and std::basic_istream< _CharT, _Traits >::unget().

const fmtflags std::ios_base::hex`[static, inherited]`

Converts integer input or generates integer output in hexadecimal base.

Definition at line 265 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::_M_extract_int(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::basic_ostream< _CharT, _Traits >::operator<<().

const openmode std::ios_base::in`[static, inherited]`

Open for input. Default for `ifstream` and fstream.

Definition at line 374 of file ios_base.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

const fmtflags std::ios_base::internal`[static, inherited]`

designated.

Definition at line 270 of file ios_base.h.

Referenced by std::money_put< _CharT, _OutIter >::_M_insert(), std::__pad< _CharT, _Traits >::_S_pad(), and std::num_put< _CharT, _OutIter >::do_put().

const fmtflags std::ios_base::left`[static, inherited]`

generated output. (I.e., the thing you print is flush left.)

Definition at line 274 of file ios_base.h.

Referenced by std::money_put< _CharT, _OutIter >::_M_insert(), std::__pad< _CharT, _Traits >::_S_pad(), and __gnu_cxx::operator<<().

const fmtflags std::ios_base::oct`[static, inherited]`

Converts integer input or generates integer output in octal base.

Definition at line 277 of file ios_base.h.

Referenced by std::__int_to_char(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::num_put< _CharT, _OutIter >::_M_insert_int(), and std::basic_ostream< _CharT, _Traits >::operator<<().

const openmode std::ios_base::out`[static, inherited]`

Open for output. Default for `ofstream` and fstream.

Definition at line 377 of file ios_base.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

const fmtflags std::ios_base::right`[static, inherited]`

generated output. (I.e., the thing you print is flush right.)

Definition at line 281 of file ios_base.h.

const fmtflags std::ios_base::scientific`[static, inherited]`

Generates floating-point output in scientific notation.

Definition at line 284 of file ios_base.h.

const fmtflags std::ios_base::showbase`[static, inherited]`

output.

Definition at line 288 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::_M_extract(), std::money_put< _CharT, _OutIter >::_M_insert(), std::num_put< _CharT, _OutIter >::_M_insert_int(), and std::num_put< _CharT, _OutIter >::do_put().

const fmtflags std::ios_base::showpoint`[static, inherited]`

floating-point output.

Definition at line 292 of file ios_base.h.

const fmtflags std::ios_base::showpos`[static, inherited]`

Generates a + sign in non-negative generated numeric output.

Definition at line 295 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::_M_insert_int().

const fmtflags std::ios_base::skipws`[static, inherited]`

Skips leading white space before certain input operations.

Definition at line 298 of file ios_base.h.

const openmode std::ios_base::trunc`[static, inherited]`

Open for input. Default for `ofstream`.

Definition at line 380 of file ios_base.h.

const fmtflags std::ios_base::unitbuf`[static, inherited]`

Flushes output after each output operation.

Definition at line 301 of file ios_base.h.

const fmtflags std::ios_base::uppercase`[static, inherited]`

in generated output.

Definition at line 305 of file ios_base.h.

Referenced by std::__int_to_char(), std::num_put< _CharT, _OutIter >::_M_insert_int(), and std::num_put< _CharT, _OutIter >::do_put().

The documentation for this class was generated from the following file:

- istream